import type { Actions, Provider } from "@web3-react/types";
import { Connector } from "@web3-react/types";
declare type FormaticProvider = Provider;
/**
 * @param apiKey - apiKey which you will get from fortmatic dashboard`
 * @param network - the network with which you want to connect your wallet.
 */
export interface FortmaticConstructorArgs {
    apiKey: string;
    network?: any;
}
export declare class Fortmatic extends Connector {
    private readonly apiKey;
    private readonly network;
    fortmatic?: any;
    provider?: FormaticProvider;
    constructor(actions: Actions, { apiKey, network }: FortmaticConstructorArgs);
    private startListening;
    activate(configuration: any): Promise<void>;
    /** {@inheritdoc Connector.deactivate} */
    deactivate(): Promise<void>;
}
export {};
